<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<link REL="stylesheet" HREF="styles.css">
<title>Online label editor and repository in database</title>
</head>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0">
<table border="0" width="240" bgcolor="#476747" align="left" cellspacing="1">
  <tr>
    <th width="100%" valign="middle" align="center" nowrap><font color="#FFFFFF">Menu</font></th>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" valign="middle" align="center"><b><a href="open.asp">Open
      and manage labels</a></b></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" valign="middle" align="center"><b><a href="edit.asp">Create
      New</a></b></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#FFFFFF" valign="middle" align="center"><b>Internet
      Explorer security<br>
      </b>If the ActiveX control does not show check your security settings and
      make sure the ActiveX and scripting are enabled for the location from
      which you are running the example. Adding the location to the trusted
      sites is the fastest way to do this without changing sensitive IE
      settings.</td>
  </tr>
</table>
<h4>Online editor and label repository (reference implementation)</h4>
<p>This example consists of several pages which implement together an online
label editor and repository in MS Access database. They are implemented in ASP
(Active Server Pages), but as you will see they are fairly simple and the
implementation of similar functionality in another language/technology/database
would not be difficult. The other pages in the example contain no descriptions
and other unneeded texts in order to minimize the collateral code in them. For
details read below.</p>
<p><b>How to run the example:</b> There are several dummy labels in the
example's database so you can go to <a href="open.asp">Open and manage</a>
without creating a <a href="edit.asp">new label</a> as first step. To run the
example you need either IIS (Microsoft Internet Information Server), PWS
(Microsoft Personal WEB Server) or ALP (<a href="http://www.activelocalpages.com">Active
Local Pages</a>). For learning and initial testing purposes ALP is perhaps the
least demanding method, if you have it installed you can just re-open this page
by double-clicking the alp.site file in this directory and go through the
example. In IIS and PWS you need to create a directory on a WEB site and put all
the files there (All the alp* files are not needed in this case, but you can
leave them - they'll do no harm). Then make sure that the MDB file can be
written by the user account with which you will work (or by everyone if you are
using an internal WEB server that does not need protection). Enable ASP if it is
disabled for some reason and navigate to the URL that corresponds to the
directory in which you have stored the files.</p>
<table border="0" width="300" bgcolor="#476747" align="right" cellspacing="1">
  <tr>
    <td width="100%" valign="middle" align="center"><b><font color="#FFFFFF">What
      is and what is not implemented in this reference implementation</font></b></td>
  </tr>
  <tr>
    <td width="100%" valign="top" align="left" bgcolor="#FFFFFF">To keep the
      code compact we have not added client side code that changes images when
      the mouse hovers over them and code for other visual effects. This can be
      done of course, but is a typical DHTML technique and does not need to be
      mixed with the code strictly related to the ActiveX control.
      <p>Visual effects can be of use if you want to improve the user interface
      of the editor. For example we have not put code that enables/disables
      certain functions in regard to the current state of the ActiveX control
      and if used incorrectly they will cause script errors (just ignore the
      errors). This is very simple and a matter of checking the values of
      several properties and changing the visual appearance of the
      images/controls that invoke the function.</p>
      <p>Another feature that is not implemented in the example, but may be
      useful is database clean up. In this implementation to clean up all the
      unused images of a label you need to save it under new name and delete the
      old one.</p>
      <p>So, the example shows how to create and editor and save/load labels
      from the WEB repository. It shows the important techniques, handles only
      the important events, but skips any decorative functionality.</p>
      <p>There is no separate label view-only page, but as this is very simple
      operation there is no actual need of such in this example. To put the
      label for viewing and printing only you just need to determine in the
      script that generates the page (ASP, JSP, PHP etc.) the URL for label
      extraction and pass it to control using the OBJECT's DATA attribute. On
      such pages you can allow the user to zoom , scroll, navigate data entries
      and print, but none of them is required - put there as much functionality
      as needed. Some of the other examples show how to do so with a few lines
      of code.&nbsp;&nbsp;</td>
  </tr>
</table>
<p><b>The file list and the purpose of each file.</b></p>
<blockquote>
  <p><b>default.asp -</b> entrance (does nothing)</p>
  <p><b>open.asp</b> - A typical ASP page that shows the list of the labels in
  the database. From it you can open or delete a label.</p>
  <p><b>edit.asp</b> - The label editor implementation. There is very little ASP
  code in the page, the important code is the client side Javascript. See the
  functions in the beginning, the label ActiveX event handlers and the code in
  the events of the control elements (mostly onClick events of images).</p>
  <p><b>save.asp</b> - The labels and their elements are sent to this page by
  the edit.asp (the action is invoked from the client side without reloading the
  edit.asp itself). Save.asp supports only labels and images, text boxes are not
  supported because they rarely need to be saved separately and this will only
  add to the code footprint not showing anything important.&nbsp;</p>
  <p><b>image.asp</b> - Extracts an image from the database. When saved the
  images on the label have their <b>Src</b> property set to image.asp?ImageID=&lt;someID&gt;
  thus making all the references in the label pointing to the repository. So,
  the image.asp can be considered as image extractor for the label repository.</p>
  <p><b>label.asp</b> - Like image.asp, but extracts a label definition from the
  database.</p>
  <p><b>img</b> directory - Contains images used in the edit.asp, they have no
  direct relation to the label management.</p>
</blockquote>
<p><b>Special attention deserve:</b></p>
<p>The order in which the elements and the label itself are saved (edit.asp).
Note that the <b><i>SaveLabel</i></b> function checks if there is any image to
be saved and if there is it does not save the label immediately. Instead the
label is saved after the last image has been saved - see the <b><i>OnPostCompleted</i></b>
event handler. The reason for this is the helper feature of the ActiveX that
allows the server side script that receives the data to return back URL or path
which replaces the <b>Src</b> property of the saved element. This way server
side script tells the label control how to access the data just saved (usually
this is important for images only). See what is returned to achieve this effect
in save.asp. The URL/path and the URL parameters that will be used to access the
saved element depends on how the extractor is implemented. In our case the
extractors are image.asp and label.asp, in a real world application you may need
to make them in a bit different manner. When integrating the label editing
capabilities in an application you need to plan how the URL and the parameters
will look - e.g. here we use the Image and the label ID-s to extract them from
the database, you may want to use their names or even custom parameters (set on
the client side). Our recommendation is to use virtual paths to refer the label
and the images and not relative paths like in the example (in the example this
makes it easier to deploy, but in a complex application the virtual path will
give you more benefits).</p>

</body>
</html>